﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NTL.KinectLib
{
    //*************************************************************************
    //*************************************************************************
    //【CLASS】『RectangleWaveFilter』【矩形波相関フィルタ】
    //*************************************************************************
    //*************************************************************************
    public class RectangleWaveFilter
    {
        private int nFIFO;
        private int ptr0 = 0;
        private int ptr1 = 0;
        private int ptr2 = 0;
        private double[] FIFO;
        private double sum;
        private double K;

        //***************************************************************
        //【矩形波相関フィルタ】★初期化
        //***************************************************************
        public void Initialize(int n)
        {
            int n4 = n / 4;
            nFIFO = n4 * 4;
            ptr0 = 0;
            ptr1 = n4;
            ptr2 = 3 * n4;
            K = 1.0 / (double)nFIFO;
            sum = 0.0;
            FIFO = new double[nFIFO];
            for (int i = 0; i < nFIFO; i++) { FIFO[i] = 0.0; }
        }

        //***************************************************************
        //【矩形波相関フィルタ】
        //***************************************************************
        public double CrossCorrelationFilter(double d)
        {
            sum += -d + 2 * (FIFO[ptr2] - FIFO[ptr1]) + FIFO[ptr0];
            FIFO[ptr0] = d;
            ptr0++; if (ptr0 == nFIFO) { ptr0 = 0; }
            ptr1++; if (ptr1 == nFIFO) { ptr1 = 0; }
            ptr2++; if (ptr2 == nFIFO) { ptr2 = 0; }
            return sum * K;
        }
    }
}
